package de.duehl.algorithm.backtracking.eightqueens;

import de.duehl.algorithm.backtracking.AlgorithmSolutionStep;

public class EightQueensStep implements AlgorithmSolutionStep {

    private final Square square;

    public EightQueensStep(Square square) {
        this.square = square;
    }

    public Square getSquare() {
        return square;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((square == null) ? 0 : square.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        EightQueensStep other = (EightQueensStep) obj;
        if (square == null) {
            if (other.square != null) {
                return false;
            }
        }
        else if (!square.equals(other.square)) {
            return false;
        }
        return true;
    }

}
