package de.duehl.math.graph.ged.animation.io;

import java.util.List;

import de.duehl.basics.collections.CollectionsHelper;
import de.duehl.basics.io.Charset;
import de.duehl.basics.io.FileHelper;
import de.duehl.math.graph.ged.graph.Graph;
import de.duehl.math.graph.ged.graph.io.ged4.Variable;

public class AnimationSaver {

    static final Charset CHARSET = Charset.UTF_8;
    static final String NUMBER_OF_GRAPHS_IN_ANIMATION = "number-of-graphs-in-animation";
    static final String SEPARATOR = "----------";

    public void save(List<Graph> graphs, String filename) {
        String anmiationFileContent = createAnimationFileContent(graphs);
        FileHelper.writeTextToFile(anmiationFileContent, filename, CHARSET);
    }

    private String createAnimationFileContent(List<Graph> graphs) {
        StringBuilder builder = new StringBuilder();

        List<Variable> animationVariables = CollectionsHelper.buildListFrom(
                new Variable(NUMBER_OF_GRAPHS_IN_ANIMATION, graphs.size())
                );

        for (Variable variable : animationVariables) {
            builder.append(variable.toString()).append("\n");
        }

        for (Graph graph : graphs) {
            builder.append(SEPARATOR).append("\n");
            builder.append(graph.saveToGed4Format());
        }

        return builder.toString();
    }

}
