package de.duehl.math.graph.ged.graph.io;

import de.duehl.math.graph.ged.graph.Graph;
import de.duehl.math.graph.ged.graph.MetaData;
import de.duehl.math.graph.ged.graph.edge.AdjacenceLists;
import de.duehl.math.graph.ged.graph.vertex.Vertices;

/**
 * Diese Klasse erzeugt eine Darstellung des Graphen in ged1-Format zum Speichern in einer Datei.
 *
 * @version 1.01     2019-05-21
 * @author Christian Dühl
 */

public class Ged1FormatSaver {

    /** Eckenmenge des Graphen. */
    @SuppressWarnings("unused")
    private final Vertices vertices;

    /** Kantenmenge des Graphen in Form von Adjazenzlisten. */
    @SuppressWarnings("unused")
    private final AdjacenceLists adjacenceLists;

    /** Enthält weitere Informationen zum Graphen. */
    @SuppressWarnings("unused")
    private MetaData meta;

    /**
     * Konstruktor.
     *
     * @param graph
     *            Der zu speichernde Graph.
     */
    public Ged1FormatSaver(Graph graph) {
        this.meta = graph.getMeta();
        this.vertices = graph.getVertices();
        this.adjacenceLists = graph.getAdjacenceLists();
    }

    /** Gibt den Graphen als String gespeichert im ged1-Format zurück. */
    public String createSaveString() {
        return ""; // TODO
    }

}
