package de.duehl.math.graph.ged.graph.vertex;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Diese Klasse stellt die Ecken eines Graphen dar.
 *
 * @version 1.01     2019-05-17
 * @author Christian Dühl
 */

public class Vertices implements Iterable<Vertex> {

    /** Eckenmenge */
    private final List<Vertex> vertices;

    public Vertices() {
        vertices = new ArrayList<Vertex>();
    }

    /** Schreibt die richtigen Indices in alle Ecken. */
    @SuppressWarnings("unused")
    synchronized
    private void reorganizeVertexIndices() {
        for (int index=0; index<vertices.size(); ++index) {
            Vertex vertex = vertices.get(index);
            vertex.setIndex(index);
        }
    }

    @Override
    public Iterator<Vertex> iterator() {
        return vertices.iterator();
    }

    public void add(Vertex vertex) {
        vertices.add(vertex);
    }

    public int size() {
        return vertices.size();
    }

    public Vertex get(int index) {
        return vertices.get(index);
    }

    public boolean contains(Vertex vertex) {
        return vertices.contains(vertex);
    }

    public void remove(int index) {
        vertices.remove(index);
    }

    /** Liefert die Liste mit den Ecken zurück. */
    public List<Vertex> getVertices() { // TODO Verwendung vermeiden...
        return vertices;
    }

    public void clear() {
        vertices.clear();
    }

    public boolean isEmpty() {
        return vertices.isEmpty();
    }

}
