package de.duehl.math.graph.ged.ui.creation.menu;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

import de.duehl.math.graph.ged.logic.Logic;
import de.duehl.swing.ui.menu.MyMenuItem;
import de.duehl.swing.ui.menu.SingleMenuCreation;

/**
 * Diese Klasse stellt die Methoden zur Verfügung, um das Extra-Menü für die grafische Oberfläche
 * zu erstellen.
 *
 * @version 1.01     2019-05-22
 * @author Christian Dühl
 */

public class ExtraMenuCreation implements SingleMenuCreation {

    /** Verbindung zur Programmlogik. */
    private final Logic logic;

    /**
     * Konstruktor.
     *
     * @param logic
     *            Verbindung zur Programmlogik.
     */
    public ExtraMenuCreation(Logic logic) {
        this.logic = logic;
    }

    /** Erzeugt das Extramenü. */
    @Override
    public JMenu createTheMenu() {
        JMenu menu = new JMenu("Extra");
        menu.setMnemonic('e');

        menu.add(createShowGraphAsTextOutputMenuItem());

        return menu;
    }

    private JMenuItem createShowGraphAsTextOutputMenuItem() {
        return new MyMenuItem("Graphen als Textausgabe ansehen")
                .mnemonic('t')
                //.accelerator(KeyEvent.VK_F5, 0)
                .actionListener(e -> logic.showGraph());
    }

}
