#!/usr/bin/perl
#------------------------------------------------------------------------------
# Programm         : g e d . p l
#------------------------------------------------------------------------------
# Autor            : Christian Dühl
# Erstellt         : 31. Januar 2003
# Zuletzt geändert : 21. Januar 2005
# Aufgabe          : Ein grafischer Editor für Graphen.
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Pakete / Pragmas
#------------------------------------------------------------------------------
use strict;
use warnings;


use FindBin;
use lib "$FindBin::RealBin";

use Graph::GED::Core;


#------------------------------------------------------------------------------
# Run Tests:
#------------------------------------------------------------------------------
#use Graph::GED::Test;
#Graph::GED::Test::geom_test();
#Graph::GED::Test::historie_test();
#Graph::GED::Test::clone_test();


#------------------------------------------------------------------------------
# Programmstart:
#------------------------------------------------------------------------------
Graph::GED::Core::start();


__END__

=head1 NAME

ged.pl - a Graph EDitor with a Perl/Tk gui

=head1 CONTENTS

    After distributing all functions and global data to the modules

=over

=item Graph::GED::Core

=item Graph::GED::Data

=item Graph::GED::Gui

=item Graph::GED::Logic

=item Graph::GED::Test

=item Graph::GED::Text

=back

    there are no functions left.

=head1 COPYRIGHT


Copyright 2004-2005 Christian Duehl. All rights reserved.

This program is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
