package de.duehl.math.geometry;

/*
 * Copyright 2016 Christian Dühl. All rights reserved.
 *
 * This program is free software. You can redistribute it and/or
 * modify it under the same terms as perl:
 *
 * general:  http://dev.perl.org/licenses/
 * GPL:      http://dev.perl.org/licenses/gpl1.html
 * artistic: http://dev.perl.org/licenses/artistic.html
 */

import static org.junit.Assert.*;

import org.junit.Test;

import de.duehl.math.geometry.Line;
import de.duehl.math.geometry.Point;

public class LineTest {

    @Test
    public void create1() {
        assertNotNull(new Line());
    }

    @Test
    public void create2() {
        Point p1 = new Point(12.02, 17.87);
        Point p2 = new Point(25.24, 21.75);
        assertNotNull(new Line(p1, p2));
    }

    @Test
    public void create3() {
        Point p1 = new Point(12.02, 17.87);
        Point p2 = new Point(25.24, 21.75);
        Line line = new Line(p1, p2);
        assertNotNull(new Line(line));
    }

    @Test
    public void equalsAndNotSame() {
        Point p1 = new Point(12.02, 17.87);
        Point p2 = new Point(25.24, 21.75);
        Line line1 = new Line(p1, p2);
        Line line2 = new Line(line1);
        assertTrue(line1 != line2);
        assertEquals(line1, line2);
    }

    @Test
    public void equalsAndNotSameSwap() {
        Point p1 = new Point(12.02, 17.87);
        Point p2 = new Point(25.24, 21.75);
        Line line1 = new Line(p1, p2);
        Line line2 = new Line(p2, p1);
        line1.swap();
        assertTrue(line1 != line2);
        assertEquals(line1, line2);
    }

}
